package com.example;

import java.util.logging.Logger;

import jakarta.decorator.Decorator;
import jakarta.decorator.Delegate;
import jakarta.inject.Inject;

@Decorator
public class InterfaceDecorator implements Interface {
  @Inject
  @Delegate
  Interface delegate;

  private static final Logger logger = Logger.getLogger(InterfaceDecorator.class.getName());

  @Override
  public int getWithDefault() {
    logger.info("decorator called");
    return delegate.getWithDefault();
  }
  @Override
  public int get() {
    logger.info("decorator called");
    return delegate.get();
  }
}
